Package ru.bitel.bgbilling.modules.botmanager.common.service

# Interface BotManagerService

public interface BotManagerService

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `clearStatisticByBotId(int botId)`
  Удаляет статистику для бота.
  `void`
  `clearStatisticByContractId(int contractId)`
  `void`
  `deleteBot(int botId)`
  `void`
  `deleteDialog(BotDialog dialog)`
  `void`
  `deleteDialogElement(BotDialogElement element)`
  `void`
  `deleteDialogGroup(BotDialogGroup group)`
  `List<Bot>`
  `getBots()`
  Key - token бота, value - экземпляр бота
  `BotDialog`
  `getDialogByCommand(String command)`
  `BotDialog`
  `getDialogById(int dialogId)`
  `List<BotDialogElement>`
  `getDialogElements()`
  `List<BotDialogGroup>`
  `getDialogGroups()`
  `List<DialogProcessingWrapper>`
  `getDialogProcessingClasses()`
  `List<BotDialog>`
  `getDialogs()`
  `List<BotDialog>`
  `getDialogsByGroupId(int dialogGroupId)`
  Получение всех диалогов из группы
  `List<BotDialogElement>`
  `getElementsByIds(List<Integer> ids)`
  `List<BotDialogElement>`
  `getElementsOfDialog(int dialogId)`
  `byte[]`
  `getFile(int elementId)`
  `SearchResult<StatisticNote>`
  `getStatistic(Page page)`
  `List<StatisticNote>`
  `getStatisticByContractId(int contractId)`
  `void`
  `reloadDialogProcessingClasses()`
  Обновляет список обработчиков диалогов
  `void`
  `setFile(BotDialogElement element, byte[] imageBytes)`
  `void`
  `updateBot(Bot bot)`
  Обновление данных бота.
  `void`
  `updateDialog(BotDialog dialog)`
  `int`
  `updateDialogElement(BotDialogElement element)`
  `void`
  `updateDialogElements(List<BotDialogElement> elements)`
  `void`
  `updateDialogGroup(BotDialogGroup group)`
  `void`
  `updateDialogGroups(List<BotDialogGroup> groups)`
  `void`
  `updateSortPositionOfElements(Map<Integer,Integer> elementSorting)`
  Обновление сортировки

- ## Method Details

  - ### getBots

    List<Bot> getBots() throws Exception
    Key - token бота, value - экземпляр бота
    Returns:
      список созданных ботов
    Throws:
      `Exception`

  - ### updateBot

    void updateBot(Bot bot) throws Exception
    Обновление данных бота. Если он запущен, то обновление будет произведено сразу
    Parameters:
      `bot` - бот с изменёнными параметрами для обновления
    Throws:
      `BGException` - в случае, если не удалось обновить конфигурацию бота
      `Exception`

  - ### deleteBot

    void deleteBot(int botId) throws Exception
    Throws:
      `Exception`

  - ### getDialogs

    List<BotDialog> getDialogs() throws Exception
    Throws:
      `Exception`

  - ### getDialogById

    BotDialog getDialogById(int dialogId) throws Exception
    Throws:
      `Exception`

  - ### getDialogByCommand

    BotDialog getDialogByCommand(String command) throws Exception
    Throws:
      `Exception`

  - ### updateDialog

    void updateDialog(BotDialog dialog) throws Exception
    Throws:
      `Exception`

  - ### deleteDialog

    void deleteDialog(BotDialog dialog) throws Exception
    Throws:
      `Exception`

  - ### getDialogElements

    List<BotDialogElement> getDialogElements() throws Exception
    Returns:
      список элементов для построения диалогов
    Throws:
      `Exception`

  - ### updateDialogElement

    int updateDialogElement(BotDialogElement element) throws Exception
    Throws:
      `Exception`

  - ### updateDialogElements

    void updateDialogElements(List<BotDialogElement> elements) throws Exception
    Throws:
      `Exception`

  - ### deleteDialogElement

    void deleteDialogElement(BotDialogElement element) throws Exception
    Throws:
      `Exception`

  - ### getElementsByIds

    List<BotDialogElement> getElementsByIds(List<Integer> ids) throws Exception
    Throws:
      `Exception`

  - ### getElementsOfDialog

    List<BotDialogElement> getElementsOfDialog(int dialogId) throws Exception
    Returns:
      список элементов для указанного диалога
    Throws:
      `Exception`

  - ### getDialogGroups

    List<BotDialogGroup> getDialogGroups() throws Exception
    Returns:
      список групп диалогов
    Throws:
      `Exception`

  - ### updateDialogGroup

    void updateDialogGroup(BotDialogGroup group) throws Exception
    Throws:
      `Exception`

  - ### updateDialogGroups

    void updateDialogGroups(List<BotDialogGroup> groups) throws Exception
    Throws:
      `Exception`

  - ### deleteDialogGroup

    void deleteDialogGroup(BotDialogGroup group) throws Exception
    Throws:
      `Exception`

  - ### getDialogsByGroupId

    List<BotDialog> getDialogsByGroupId(int dialogGroupId) throws Exception
    Получение всех диалогов из группы
    Parameters:
      `dialogGroupId` - id группы диалогов
    Returns:
      вернёт список диалогов из группы, если переданный id = -1, вернёт диалоги не состоящие ни в какой группе
    Throws:
      `BGException`
      `Exception`

  - ### reloadDialogProcessingClasses

    void reloadDialogProcessingClasses() throws Exception
    Обновляет список обработчиков диалогов
    Throws:
      `Exception`

  - ### getDialogProcessingClasses

    List<DialogProcessingWrapper> getDialogProcessingClasses() throws Exception
    Returns:
      список обработчиков диалогов
    Throws:
      `Exception`

  - ### getFile

    byte[] getFile(int elementId) throws Exception
    Throws:
      `Exception`

  - ### setFile

    void setFile(BotDialogElement element, byte[] imageBytes) throws Exception
    Throws:
      `Exception`

  - ### updateSortPositionOfElements

    void updateSortPositionOfElements(Map<Integer,Integer> elementSorting)
    Обновление сортировки
    Parameters:
      `elementSorting` - key - id элемента, value - его позиция при сортировке

  - ### getStatistic

    SearchResult<StatisticNote> getStatistic(Page page) throws Exception
    Throws:
      `Exception`

  - ### getStatisticByContractId

    List<StatisticNote> getStatisticByContractId(int contractId) throws Exception
    Throws:
      `Exception`

  - ### clearStatisticByBotId

    void clearStatisticByBotId(int botId) throws Exception
    Удаляет статистику для бота. Если передано -1, то будет очищена вся статистика
    Throws:
      `BGException`
      `Exception`

  - ### clearStatisticByContractId

    void clearStatisticByContractId(int contractId) throws Exception
    Throws:
      `Exception`